<template>
    <div class="owl-carousel owl-theme owl2" @mouseenter="stopSlider" @mouseleave="startSlider">
        <div class="owl-nav">
            <div class="owl-prev" @click="prevSlide"></div>
            <div class="owl-next" @click="nextSlide"></div>
        </div>

        <div class="sliders" ref="slider" v-if="ready">
            <transition-group
                    style="max-width: 100%;"
                    tag="div"
                    name="list"
                    @before-leave="beforeLeave"
                    @after-leave="afterLeave"
            >
                <div v-for="(item, index) in displayItems"
                     :key="item.name"
                     :style="item.style"
                     class="slide"
                     :class="{active: active, last: index === displayItems.length -1}"
                     >
                    <router-link :to="{name: 'installment-partners', params: {id: item.id}}" class="item">
                        <div class="image">
                            <img :src="item.logo"/>
                        </div>
                        <h3>{{item.name}}</h3>
                        <span>Оплата частями на 3 и 6 месяцев</span>
                    </router-link>
                </div>
            </transition-group>
        </div>

    </div>
</template>

<script>
  export default {
    name: 'carousel',
    data () {
      return {
        items: [
          // {img: '/static/tmp/pos/partners/1-1.jpg', title: 'Детский мир', time: 6},
          // {img: '/static/tmp/pos/partners/1-2.jpg', title: 'М.Видео', time: 3},
          // {img: '/static/tmp/pos/partners/1-3.jpg', title: 'laModa', time: 5},
          // {img: '/static/tmp/pos/partners/1-4.jpg', title: 'Reebok', time: 4},
          // {img: '/static/tmp/pos/partners/2-1.jpg', title: 'Anex Shop', time: 1},
          // {img: '/static/tmp/pos/partners/2-2.jpg', title: 'Mascotte', time: 4},
        ],
        index: 0,
        slideCount: 1,
        ready: false,
        width: 0,
        active: false,
      }
    },
    computed: {
      item () {
        return this.$installment.partnerShops[this.index];
      },
      list () {
        const width = this.width / this.slideCount - 20 + 'px';
        const list = [];
        this.$installment.partnerShops.forEach((item) => {
          list.push({...item, style: {width}});
        })
        return list;
      },
      displayItems () {
        const items = [];
        let idx = this.index -1;
        const width = this.width / this.slideCount - (this.slideCount === 1 ? 80 : 20) + 'px';
        for(let i = 0; i < this.slideCount; i ++) {
          idx++;
          if (idx >= this.$installment.partnerShops.length) {
            idx = 0;
          }
          const p = this.$installment.partnerShops[idx];
          if (!p) continue;
          if (!p.logo) {
            p.logo = `/lk/static/img/pos/partner/default.png`
          }
          p.time = 6;
          items.push({...p, index: idx, style: {
            width,
              left: this.slideCount === 1 ? '40px' : 0
          }})

        }
        return items;
      }
    },

    created () {

    },

    mounted () {
      this.startSlider();
      window.addEventListener('resize', this.computeSlideCount, false);
      this.ready = true;
      this.$nextTick(() => {
        this.computeSlideCount();
      })
    },

    beforeDestroy () {
      window.removeEventListener('resize', this.computeSlideCount, false);
    },

    methods: {

      beforeLeave (el) {
        this.active = true;
      },

      afterLeave (el) {
        this.active = false;
      },

      computeSlideCount () {
        this.width = this.$refs.slider.offsetWidth;
        if (this.$refs.slider.offsetWidth > 600) {
          this.slideCount = 3;
        } else if (this.$refs.slider.offsetWidth > 400) {
          this.slideCount = 2;
        } else {
          this.slideCount = 1;
        }
      },

      startSlider () {
        this.timer = setInterval(() => {
          this.nextSlide()
        }, 5000);
      },

      stopSlider () {
        clearInterval(this.timer);
      },

      nextSlide () {
        this.index >= this.$installment.partnerShops.length -1 ? this.index = 0 : this.index++;
      },
      prevSlide () {
        this.index === 0 ? this.index = this.$installment.partnerShops.length - 1 : this.index--;
      }
    }
  }
</script>

<style  lang="scss">

    .list-enter-active, .list-leave-active {
        transition: all 1s;
    }
    .list-leave-to {
        transform: translateX(calc(-100% - 20px));
    }

    .list-enter /* .list-leave-active до версии 2.1.8 */ {
        transform: translateX(calc(0 - 20px));
    }


    .owl-carousel {
        position: relative;
    }
    .owl-nav {
        height: 100%;
        position: absolute;
        top: 0;
        left: 0;
        width:100%;
        margin-top: 0 !important;

        & .owl-prev, & .owl-next {
            z-index: 3;
            background: #fafbfc;
            display: block;
            width: 40px !important;
            height:100% !important;
            top: 0 !important;

        }
    }
    .owl-theme {
        display: flex;
        margin-bottom:50px;
        & .sliders {
            & > div {
                display: flex;
            }
            width:100%;
            display: flex;
            overflow: hidden;
            & .slide {
                display: flex;
                /*margin-right:20px;*/
                position: relative;


                transition-timing-function: linear !important;
                margin: 0 20px 0 0;
                &.active {
                    transform: translateX(calc(-100% - 20px));
                    transition: all 1s;
                }


            }
        }
    }
    .owl-theme .owl-nav .owl-prev {
        left: 0;
        background:#fafbfc url(/static/img/slider/left.png) no-repeat 0% 50%;
    }

    .owl-theme .owl-nav .owl-next {
        right: 0;
        background:#fafbfc url(/static/img/slider/right.png) no-repeat 100% 50%;
    }




    .slide-leave-active,
    .slide-enter-active {
        transition: 1s;
    }
    .slide-enter {
        transform: translate(100%, 0);
    }
    .slide-leave-to {
        transform: translate(-100%, 0);
    }


</style>
